#include "fortran.h"

void
convert_number(char *s)
{
    char *p;
    char *p_exponent = (char*)NULL;
    int exponent_seen = 0;
    int exponent_value = 0;

    for (p = s; *p; ++p)
    {
	switch (*p)
	{
	case 'Q':
	case 'q':
	    if (!hp_output)
		*p += 'd' - 'q';
	    p_exponent = p;
	    exponent_seen++;
	    break;

	case 'D':
	case 'd':
	    if (hp_output)
		*p += 'q' - 'd';
	    p_exponent = p;
	    exponent_seen++;
	    break;

	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	    if (exponent_seen)
	        exponent_value = 10*exponent_value + (int)(*p - '0');
	    break;

	default:
	    break;
	}
    }
#if 0
    if (exponent_seen && (exponent_value == 0) && !hp_output)
	*p_exponent = '\0';		/* eliminate zero exponents */
#endif
    instring = 1;			/* no line breaks in numbers */
    MY_ECHO_STRING(s);
#if 0
    if (hp_output && !exponent_seen)
	MY_ECHO_STRING("Q+00");
#endif
    instring = 0;
}
